﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using System.Web.UI.HtmlControls;

namespace DataTableToHtml
{
    public partial class _Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            DataTable dt = GetTableData(); // this is your get data method or whatever

            string html = GenerateHtmlTableForDataTable(dt);

            litHtml.Text = html;
        }

        string GenerateHtmlTableForDataTable(DataTable dt)
        {
            // create a table
            System.Web.UI.HtmlControls.HtmlTable tbl = new System.Web.UI.HtmlControls.HtmlTable();
            System.Web.UI.HtmlControls.HtmlTableRow tr;
            tbl.Border = 1;
            tbl.Width = "80%";
            tbl.ID = "data-table";


            // do we have rows?
            if (dt.Rows.Count > 0)
            {
                // create the header row
                tr = new System.Web.UI.HtmlControls.HtmlTableRow();
                tr.Attributes.Add("class", "data-table-header"); // add a class style attribute

                for (int i = 0; i < dt.Columns.Count; i++)
                {
                    HtmlTableCell cell = new HtmlTableCell() { InnerText = dt.Columns[i].ColumnName };
                    cell.Attributes.Add("class", "data-table-header-cell");
                    tr.Cells.Add(cell);
                }

                tbl.Rows.Add(tr);

                // create the data rows
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    tr = new System.Web.UI.HtmlControls.HtmlTableRow();
                    tr.Attributes.Add("class", "data-table-row"); // add a class style attribute

                    for (int j = 0; j < dt.Columns.Count; j++)
                    {
                        HtmlTableCell cell = new HtmlTableCell() { InnerText = dt.Rows[i][j].ToString() };
                        cell.Attributes.Add("class", "data-table-row-cell");
                        tr.Cells.Add(cell);
                    }
                    
                    tbl.Rows.Add(tr);
                }
            }
            else
            {
                tr = new System.Web.UI.HtmlControls.HtmlTableRow();
                HtmlTableCell cell = new HtmlTableCell() { InnerText = "No data returned" };
                cell.Attributes.Add("class", "data-table-no-data");
                tr.Cells.Add(cell);
                tbl.Rows.Add(tr);
            }

            // render the table to a string
            using (System.IO.StringWriter writer = new System.IO.StringWriter())
            {
                using (HtmlTextWriter html = new HtmlTextWriter(writer))
                    tbl.RenderControl(html);

                return writer.ToString();
            }
        }

        DataTable GetTableData()
        {
            DataTable dt = new DataTable();
            DataRow dr = null;

            dt.Columns.Add("Description", System.Type.GetType("System.String"));
            dt.Columns.Add("Price", System.Type.GetType("System.Decimal"));
            dt.Columns.Add("Qty", System.Type.GetType("System.Int32"));

            for (int index = 1; index <= 10; index++)
            {
                dr = dt.NewRow();
                dr["Description"] = string.Concat("Item #", index);
                dr["Price"] = index;
                dr["Qty"] = index;

                dt.Rows.Add(dr);
            }

            return dt;
        }
    }
}