﻿Public Class _Default
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        Dim dt As DataTable = GetTableData()

        Dim html As String = GenerateHtmlTableForDataTable(dt)

        litHtml.Text = html
    End Sub

    Function GenerateHtmlTableForDataTable(ByVal dt As DataTable) As String

        ' create a table
        Dim tbl As New System.Web.UI.HtmlControls.HtmlTable()
        Dim tr As System.Web.UI.HtmlControls.HtmlTableRow
        tbl.Border = 1
        tbl.Width = "80%"
        tbl.ID = "data-table"


        ' do we have rows?
        If dt.Rows.Count > 0 Then

            ' create the header row
            tr = New System.Web.UI.HtmlControls.HtmlTableRow()
            tr.Attributes.Add("class", "data-table-header")

            ' add a class style attribute
            For i As Integer = 0 To dt.Columns.Count - 1
                Dim cell As New HtmlTableCell() With {.InnerText = dt.Columns(i).ColumnName}
                cell.Attributes.Add("class", "data-table-header-cell")
                tr.Cells.Add(cell)
            Next

            tbl.Rows.Add(tr)

            ' create the data rows
            For i As Integer = 0 To dt.Rows.Count - 1

                tr = New System.Web.UI.HtmlControls.HtmlTableRow()
                tr.Attributes.Add("class", "data-table-row")

                ' add a class style attribute
                For j As Integer = 0 To dt.Columns.Count - 1
                    Dim cell As New HtmlTableCell() With {.InnerText = dt.Rows(i)(j).ToString()}
                    cell.Attributes.Add("class", "data-table-row-cell")
                    tr.Cells.Add(cell)
                Next

                tbl.Rows.Add(tr)
            Next
        Else
            tr = New System.Web.UI.HtmlControls.HtmlTableRow()
            Dim cell As New HtmlTableCell() With {.InnerText = "No data returned"}
            cell.Attributes.Add("class", "data-table-no-data")
            tr.Cells.Add(cell)
            tbl.Rows.Add(tr)
        End If

        ' render the table to a string
        Using writer As New System.IO.StringWriter()
            Using html As New HtmlTextWriter(writer)
                tbl.RenderControl(html)
            End Using

            Return writer.ToString()
        End Using
    End Function


    Function GetTableData() As DataTable

        Dim dt As New DataTable()
        Dim dr As DataRow

        dt.Columns.Add("Description", System.Type.GetType("System.String"))
        dt.Columns.Add("Price", System.Type.GetType("System.Decimal"))
        dt.Columns.Add("Qty", System.Type.GetType("System.Int32"))

        For index As Integer = 1 To 10
            dr = dt.NewRow()
            dr("Description") = String.Concat("Item #", index)
            dr("Price") = index
            dr("Qty") = index

            dt.Rows.Add(dr)
        Next

        Return dt
    End Function
End Class